#include<iostream>
#include<vector>
#include<queue>

using namespace std;

bool bit(int ind, int n)
{
  n /= (1<<ind);
  return bool(n%2);
}

int main()
{
  long long N;
  cin >> N;
  vector<int> v(N);
  for(int i=0;i<N;i++)
    cin >> v[i];
  vector<vector<int> > g(N);
  for(int i=0;i<N-1;i++)
  {
      int a,b;
      cin >> a >> b;
      g[a].push_back(b);
      g[b].push_back(a);
  }
  long long sum = 0;
  for(int bi=0;bi<20;bi++)
  {
    bool used[N];
    for(int i=0;i<N;i++)
      if(bit(bi,v[i]))
      {
        used[i] = 0;
      }
      else used[i] = 1;
    queue<int> q;
    for(int i=0;i<N;i++)
    {
      if(!used[i])
      {
        long long size = 1;
        q.push(i);
        used[i] = 1;
        while(!q.empty())
        {
          int tmp = q.front();
          q.pop();
          for(auto i:g[tmp])
            if(!used[i])
              {
                q.push(i);
                used[i] =1;
                size++;
              }
        }
        sum += (size*(size+1)/2)*(1<<bi);
      }
    }
  }
  cout << sum << endl;
}
